#include <openssl/rand.h>
#include <openssl/rsa.h>
#include <openssl/rc4.h>
#include <string.h>
#include "sizes.h"

int ciphertext(
  unsigned char *c,unsigned long long *clen,
  const unsigned char *m,const unsigned long long mlen,
  const unsigned char pk[PUBLICKEY_BYTES],const unsigned long long pklen
)
{
  unsigned char key[16];
  RSA *r;
  RC4_KEY k;
  int len;

  if (mlen > 1000000000) return -1;
  *clen = mlen + MODULUS_BYTES;

  r = RSA_new();
  if (!r) return -1;

  r->n = BN_new(); if (!r->n) goto error;
  if (!BN_bin2bn(pk,MODULUS_BYTES,r->n)) goto error;
  r->e = BN_new(); if (!r->n) goto error;
  if (!BN_set_word(r->e,3)) goto error;
  if (RSA_size(r) > MODULUS_BYTES) goto error;

  do {
    if (!RAND_bytes(key,16)) goto error;
    len = RSA_public_encrypt(16,key,c,r,RSA_PKCS1_PADDING);
    if (len < 0) goto error;
  } while (len != MODULUS_BYTES);

  RC4_set_key(&k,16,key);
  RC4(&k,mlen,m,c + MODULUS_BYTES);

  RSA_free(r);
  return 0;

  error:
  RSA_free(r);
  return -1;
}
