#include <memory.h>

typedef unsigned long u32;
typedef unsigned char u8;

#include "lib_sha1.h"

unsigned char SEED_tab[55];
unsigned char SEED_rando[20];
unsigned char SEED_pos;

void 
init_rando(unsigned char *seed, int n)
{
	if(n>53)
	{
		n=53;
	}

	memset(SEED_tab,0,53);
	memcpy(SEED_tab,seed,n);

	SEED_pos=19;
}

void 
update_rando(void)
{
	SEED_tab[54] ++;
	if(!SEED_tab[54])
	{
		SEED_tab[53]++;
		if(!SEED_tab[53])
		{
			SEED_tab[52]++;
			if(!SEED_tab[52])
			{
				SEED_tab[51]++;
			}
		}

	}
	sha1(SEED_rando,SEED_tab,55*8);
}

unsigned char 
rando(void)
{
	if(SEED_pos==19)
	{
		update_rando();
		SEED_pos=-1;
	}

	SEED_pos ++;

	return (SEED_rando[SEED_pos] & 127);

}

unsigned char
rando2(void)
{
	return rando()%2;
}

unsigned char
rando8(void)
{
	return rando();
}

unsigned long
rando32(void)
{
	unsigned long retour;

	retour = rando();
	retour += rando() << 8;
	retour += rando() <<16;
	retour += rando() <<24;
	return retour;
}
