#include <stdio.h>
#include <string.h>

void SHA1Transform(unsigned int save[5],const unsigned char buffer[64]);

#define rol(value, bits) (((value) << (bits)) | ((value) >> (32 - (bits))))

#ifdef MY_LITTLE_ENDIAN
	#define blk0(i) (((unsigned int *) block)[i] = (rol(((unsigned int *) block)[i],24)&0xFF00FF00)|(rol(((unsigned int *) block)[i],8)&0x00FF00FF))
#else
	#define blk0(i) ((unsigned int *) block)[i]
#endif

#define blk(i) (((unsigned int *) block)[i&15] = rol(((unsigned int *) block)[(i+13)&15]^((unsigned int *) block)[(i+8)&15] ^ ((unsigned int *) block)[(i+2)&15]^((unsigned int *) block)[i&15],1))

#define R0(v,w,x,y,z,i) z += ((w & (x^y)) ^ y)		+ blk0(i) + 0x5A827999 + rol(v,5); w=rol(w,30);
#define R1(v,w,x,y,z,i) z += ((w & (x^y)) ^ y)		+ blk(i)  + 0x5A827999 + rol(v,5); w=rol(w,30);
#define R2(v,w,x,y,z,i) z += ( w ^ x ^ y)			+ blk(i)  + 0x6ED9EBA1 + rol(v,5); w=rol(w,30);
#define R3(v,w,x,y,z,i) z += (((w|x) & y) | (w&x))	+ blk(i)  + 0x8F1BBCDC + rol(v,5); w=rol(w,30);
#define R4(v,w,x,y,z,i) z += ( w ^ x ^ y)			+ blk(i)  + 0xCA62C1D6 + rol(v,5); w=rol(w,30);

void
affiche(unsigned char t[64],int n)
{
	int i;
	printf("\n");
	for(i=0;i<n;i++)
	{
		printf("%.2X",t[i]);
	}
}

void
SHA1Transform(unsigned int save[5],const unsigned char buffer[64])
{
	unsigned int a, b, c, d, e;

	unsigned char block[64];
    memcpy(block, buffer, 64);

    a = save[0];
    b = save[1];
    c = save[2];
    d = save[3];
    e = save[4];
    
	R0(a,b,c,d,e, 0); R0(e,a,b,c,d, 1); R0(d,e,a,b,c, 2); R0(c,d,e,a,b, 3);
    R0(b,c,d,e,a, 4); R0(a,b,c,d,e, 5); R0(e,a,b,c,d, 6); R0(d,e,a,b,c, 7);
    R0(c,d,e,a,b, 8); R0(b,c,d,e,a, 9); R0(a,b,c,d,e,10); R0(e,a,b,c,d,11);
    R0(d,e,a,b,c,12); R0(c,d,e,a,b,13); R0(b,c,d,e,a,14); R0(a,b,c,d,e,15);
	R1(e,a,b,c,d,16); R1(d,e,a,b,c,17); R1(c,d,e,a,b,18); R1(b,c,d,e,a,19);

    R2(a,b,c,d,e,20); R2(e,a,b,c,d,21); R2(d,e,a,b,c,22); R2(c,d,e,a,b,23);
    R2(b,c,d,e,a,24); R2(a,b,c,d,e,25); R2(e,a,b,c,d,26); R2(d,e,a,b,c,27);
    R2(c,d,e,a,b,28); R2(b,c,d,e,a,29); R2(a,b,c,d,e,30); R2(e,a,b,c,d,31);
    R2(d,e,a,b,c,32); R2(c,d,e,a,b,33); R2(b,c,d,e,a,34); R2(a,b,c,d,e,35);
    R2(e,a,b,c,d,36); R2(d,e,a,b,c,37); R2(c,d,e,a,b,38); R2(b,c,d,e,a,39);
    
	R3(a,b,c,d,e,40); R3(e,a,b,c,d,41); R3(d,e,a,b,c,42); R3(c,d,e,a,b,43);
    R3(b,c,d,e,a,44); R3(a,b,c,d,e,45); R3(e,a,b,c,d,46); R3(d,e,a,b,c,47);
    R3(c,d,e,a,b,48); R3(b,c,d,e,a,49); R3(a,b,c,d,e,50); R3(e,a,b,c,d,51);
    R3(d,e,a,b,c,52); R3(c,d,e,a,b,53); R3(b,c,d,e,a,54); R3(a,b,c,d,e,55);
    R3(e,a,b,c,d,56); R3(d,e,a,b,c,57); R3(c,d,e,a,b,58); R3(b,c,d,e,a,59);
    
	R4(a,b,c,d,e,60); R4(e,a,b,c,d,61); R4(d,e,a,b,c,62); R4(c,d,e,a,b,63);
    R4(b,c,d,e,a,64); R4(a,b,c,d,e,65); R4(e,a,b,c,d,66); R4(d,e,a,b,c,67);
    R4(c,d,e,a,b,68); R4(b,c,d,e,a,69); R4(a,b,c,d,e,70); R4(e,a,b,c,d,71);
    R4(d,e,a,b,c,72); R4(c,d,e,a,b,73); R4(b,c,d,e,a,74); R4(a,b,c,d,e,75);
    R4(e,a,b,c,d,76); R4(d,e,a,b,c,77); R4(c,d,e,a,b,78); R4(b,c,d,e,a,79);
    
	save[0] += a;
    save[1] += b;
    save[2] += c;
    save[3] += d;
    save[4] += e;
    
}


void
testdef(void)
{
	{
		unsigned int i=1;
		unsigned char *p = (unsigned char *) &i;
		#ifdef MY_LITTLE_ENDIAN
				if(p[0]!=1)
				{
					fprintf(stderr,"BIG ENDIAN declared as LITTLE ENDIAN (cf lib_sha1.c)\n");
					exit(100);
				}
		#else
				if(p[0]!=0)
				{
					fprintf(stderr,"LITTLE ENDIAN declared as BIG ENDIAN (cf lib_sha1.c)\n");
					exit(100);
				}
		#endif
	}

}

void 
sha1(unsigned char digest[20],const unsigned char *data, unsigned long len)
{
	unsigned int i;
	unsigned char buffer[64];
	unsigned int save[5] = { 0x67452301, 0xEFCDAB89, 0x98BADCFE, 0x10325476, 0xC3D2E1F0 };

	testdef();

	for(i=0;i<len/512;i++)
	{
        SHA1Transform(save, &(data[64*i]));
	}

	if(len%512==0)
	{
		memset(buffer,0,64);
		buffer[0]= 0x80;
	}
	else
	{
		if(len%8==0)
		{
			memset(buffer,0,64);
			memcpy(buffer, &data[64*i], (len%512)/8);
			buffer[(len%512)/8] = 0x80;
		}
		else
		{
			memset(buffer,0,64);
			memcpy(buffer, &data[64*i], (len%512)/8+1);
			buffer[(len%512)/8] |= 0x80 >> (len%8);
		}

		if(len%512 >= 448)
		{
			SHA1Transform(save, buffer);
			memset(buffer,0,64);
		}
	}
	buffer[63] = (unsigned char) (len		& 0x000000FF);
	buffer[62] = (unsigned char) (len >>8	& 0x000000FF);
	buffer[61] = (unsigned char) (len >>16	& 0x000000FF);
	buffer[60] = (unsigned char) (len >>24	& 0x000000FF);

    SHA1Transform(save, buffer);

    for (i=0; i<20; i++) 
	{
        digest[i] = (unsigned char) ((save[i/4] >> ((3-(i%4))*8)) % 256);
    }

}
