/*
 * Library MPFq, package mp.
 * Multiprecision routines (small number of words) for x86_64. 
 * Automatically generated by perl/gen_mp_x86_64.pl 
 */

#ifndef __MP_X86_64_H__
#define __MP_X86_64_H__

#define HAVE_NATIVE_ADDMUL1_1 1
static void 
addmul1_1(mp_limb_t *z, const mp_limb_t *x, const mp_limb_t c)
{
  __asm__ volatile(
   "    movq    %2, %%rax\n"
   "    mulq    %[mult]\n"
   "    addq    %%rax, %0\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"
   "    addq    %%rcx, %1\n"
  : "+rm" (z[0]), "+rm" (z[1])
  : "rm" (x[0]), [mult] "r" (c)
  : "%rax", "%rcx", "%rdx");
}

#define HAVE_NATIVE_ADDMUL1_2 1
static void
addmul1_2(mp_limb_t *z, const mp_limb_t *x, const mp_limb_t c)
{
  __asm__ volatile(
   "    movq    %3, %%rax\n"
   "    mulq    %[mult]\n"
   "    addq    %%rax, %0\n"
   "    movq    %4, %%rax\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    addq    %%rcx, %1\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    addq    %%rcx, %2\n"
  : "+m" (z[0]), "+m" (z[1]), "+m" (z[2])
  : "m" (x[0]), "m" (x[1]), [mult] "r" (c)
  : "%rax", "%rcx", "%rdx");
}

#define HAVE_NATIVE_ADDMUL1_3 1
static void
addmul1_3(mp_limb_t *z, const mp_limb_t *x, const mp_limb_t c)
{
  __asm__ volatile(
   "    movq    %4, %%rax\n"
   "    mulq    %[mult]\n"
   "    addq    %%rax, %0\n"
   "    movq    %5, %%rax\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %6, %%rax\n"
   "    addq    %%rcx, %1\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    addq    %%rcx, %2\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    addq    %%rcx, %3\n"
  : "+m" (z[0]), "+m" (z[1]), "+m" (z[2]), "+m" (z[3])
  : "m" (x[0]), "m" (x[1]), "m" (x[2]), [mult] "r" (c)
  : "%rax", "%rcx", "%rdx");
}

#define HAVE_NATIVE_ADDMUL1_4 1
static void
addmul1_4(mp_limb_t *z, const mp_limb_t *x, const mp_limb_t c)
{
  __asm__ volatile(
   "    movq    %5, %%rax\n"
   "    mulq    %[mult]\n"
   "    addq    %%rax, %0\n"
   "    movq    %6, %%rax\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %7, %%rax\n"
   "    addq    %%rcx, %1\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %8, %%rax\n"
   "    addq    %%rcx, %2\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    addq    %%rcx, %3\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    addq    %%rcx, %4\n"
  : "+m" (z[0]), "+m" (z[1]), "+m" (z[2]), "+m" (z[3]), "+m" (z[4])
  : "m" (x[0]), "m" (x[1]), "m" (x[2]), "m" (x[3]), [mult] "r" (c)
  : "%rax", "%rcx", "%rdx");
}

#define HAVE_NATIVE_ADDMUL1_5 1
static void
addmul1_5(mp_limb_t *z, const mp_limb_t *x, const mp_limb_t c)
{
  __asm__ volatile(
   "    movq    %0, %%rdi\n"
   "    movq    %1, %%rsi\n"
   "    movq    (%%rsi), %%rax\n"
   "    mulq    %[mult]\n"
   "    addq    %%rax, (%%rdi)\n"
   "    movq    8(%%rsi), %%rax\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    16(%%rsi), %%rax\n"
   "    addq    %%rcx, 8(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    24(%%rsi), %%rax\n"
   "    addq    %%rcx, 16(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    32(%%rsi), %%rax\n"
   "    addq    %%rcx, 24(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    addq    %%rcx, 32(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    addq    %%rcx, 40(%%rdi)\n"
  : "+m" (z)
  : "m" (x), [mult] "r" (c)
  : "%rax", "%rcx", "%rdx", "%rsi", "%rdi", "memory");
}

#define HAVE_NATIVE_ADDMUL1_6 1
static void
addmul1_6(mp_limb_t *z, const mp_limb_t *x, const mp_limb_t c)
{
  __asm__ volatile(
   "    movq    %0, %%rdi\n"
   "    movq    %1, %%rsi\n"
   "    movq    (%%rsi), %%rax\n"
   "    mulq    %[mult]\n"
   "    addq    %%rax, (%%rdi)\n"
   "    movq    8(%%rsi), %%rax\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    16(%%rsi), %%rax\n"
   "    addq    %%rcx, 8(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    24(%%rsi), %%rax\n"
   "    addq    %%rcx, 16(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    32(%%rsi), %%rax\n"
   "    addq    %%rcx, 24(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    40(%%rsi), %%rax\n"
   "    addq    %%rcx, 32(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    addq    %%rcx, 40(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    addq    %%rcx, 48(%%rdi)\n"
  : "+m" (z)
  : "m" (x), [mult] "r" (c)
  : "%rax", "%rcx", "%rdx", "%rsi", "%rdi", "memory");
}

#define HAVE_NATIVE_ADDMUL1_7 1
static void
addmul1_7(mp_limb_t *z, const mp_limb_t *x, const mp_limb_t c)
{
  __asm__ volatile(
   "    movq    %0, %%rdi\n"
   "    movq    %1, %%rsi\n"
   "    movq    (%%rsi), %%rax\n"
   "    mulq    %[mult]\n"
   "    addq    %%rax, (%%rdi)\n"
   "    movq    8(%%rsi), %%rax\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    16(%%rsi), %%rax\n"
   "    addq    %%rcx, 8(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    24(%%rsi), %%rax\n"
   "    addq    %%rcx, 16(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    32(%%rsi), %%rax\n"
   "    addq    %%rcx, 24(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    40(%%rsi), %%rax\n"
   "    addq    %%rcx, 32(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    48(%%rsi), %%rax\n"
   "    addq    %%rcx, 40(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    addq    %%rcx, 48(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    addq    %%rcx, 56(%%rdi)\n"
  : "+m" (z)
  : "m" (x), [mult] "r" (c)
  : "%rax", "%rcx", "%rdx", "%rsi", "%rdi", "memory");
}

#define HAVE_NATIVE_ADDMUL1_8 1
static void
addmul1_8(mp_limb_t *z, const mp_limb_t *x, const mp_limb_t c)
{
  __asm__ volatile(
   "    movq    %0, %%rdi\n"
   "    movq    %1, %%rsi\n"
   "    movq    (%%rsi), %%rax\n"
   "    mulq    %[mult]\n"
   "    addq    %%rax, (%%rdi)\n"
   "    movq    8(%%rsi), %%rax\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    16(%%rsi), %%rax\n"
   "    addq    %%rcx, 8(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    24(%%rsi), %%rax\n"
   "    addq    %%rcx, 16(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    32(%%rsi), %%rax\n"
   "    addq    %%rcx, 24(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    40(%%rsi), %%rax\n"
   "    addq    %%rcx, 32(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    48(%%rsi), %%rax\n"
   "    addq    %%rcx, 40(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    56(%%rsi), %%rax\n"
   "    addq    %%rcx, 48(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    addq    %%rcx, 56(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    addq    %%rcx, 64(%%rdi)\n"
  : "+m" (z)
  : "m" (x), [mult] "r" (c)
  : "%rax", "%rcx", "%rdx", "%rsi", "%rdi", "memory");
}

#define HAVE_NATIVE_ADDMUL1_9 1
static void
addmul1_9(mp_limb_t *z, const mp_limb_t *x, const mp_limb_t c)
{
  __asm__ volatile(
   "    movq    %0, %%rdi\n"
   "    movq    %1, %%rsi\n"
   "    movq    (%%rsi), %%rax\n"
   "    mulq    %[mult]\n"
   "    addq    %%rax, (%%rdi)\n"
   "    movq    8(%%rsi), %%rax\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    16(%%rsi), %%rax\n"
   "    addq    %%rcx, 8(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    24(%%rsi), %%rax\n"
   "    addq    %%rcx, 16(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    32(%%rsi), %%rax\n"
   "    addq    %%rcx, 24(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    40(%%rsi), %%rax\n"
   "    addq    %%rcx, 32(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    48(%%rsi), %%rax\n"
   "    addq    %%rcx, 40(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    56(%%rsi), %%rax\n"
   "    addq    %%rcx, 48(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    movq    64(%%rsi), %%rax\n"
   "    addq    %%rcx, 56(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    mulq    %[mult]\n"
   "    addq    %%rax, %%rcx\n"
   "    adcq    $0, %%rdx\n"
   "    addq    %%rcx, 64(%%rdi)\n"
   "    adcq    $0, %%rdx\n"
   "    movq    %%rdx, %%rcx\n"

   "    addq    %%rcx, 72(%%rdi)\n"
  : "+m" (z)
  : "m" (x), [mult] "r" (c)
  : "%rax", "%rcx", "%rdx", "%rsi", "%rdi", "memory");
}

#define HAVE_NATIVE_ADD_1 1
static void
add_1(mp_limb_t *z, const mp_limb_t *x, const mp_limb_t *y)
{
  *z = *x + *y;
}

#define HAVE_NATIVE_ADD_2 1
static void
add_2(mp_limb_t *z, const mp_limb_t *x, const mp_limb_t *y)
{
  __asm__ volatile (
    "   movq    %2, %%rax\n"
    "   addq    %4, %%rax\n"
    "   movq    %%rax, %0\n"

    "   movq    %3, %%rax\n"
    "   adcq    %5, %%rax\n"
    "   movq    %%rax, %1\n"
  : "=m" (z[0]), "=m" (z[1])
  : "m" (x[0]), "m" (x[1]), "m" (y[0]), "m" (y[1])
  : "%rax");
}

#define HAVE_NATIVE_ADD_3 1
static void
add_3(mp_limb_t *z, const mp_limb_t *x, const mp_limb_t *y)
{
  __asm__ volatile (
    "   movq    %3, %%rax\n"
    "   addq    %6, %%rax\n"
    "   movq    %%rax, %0\n"

    "   movq    %4, %%rax\n"
    "   adcq    %7, %%rax\n"
    "   movq    %%rax, %1\n"

    "   movq    %5, %%rax\n"
    "   adcq    %8, %%rax\n"
    "   movq    %%rax, %2\n"
  : "=m" (z[0]), "=m" (z[1]), "=m" (z[2])
  : "m" (x[0]), "m" (x[1]), "m" (x[2]), "m" (y[0]), "m" (y[1]), "m" (y[2])
  : "%rax");
}

#define HAVE_NATIVE_ADD_4 1
static void
add_4(mp_limb_t *z, const mp_limb_t *x, const mp_limb_t *y)
{
  __asm__ volatile (
    "   movq    %4, %%rax\n"
    "   addq    %8, %%rax\n"
    "   movq    %%rax, %0\n"

    "   movq    %5, %%rax\n"
    "   adcq    %9, %%rax\n"
    "   movq    %%rax, %1\n"

    "   movq    %6, %%rax\n"
    "   adcq    %10, %%rax\n"
    "   movq    %%rax, %2\n"

    "   movq    %7, %%rax\n"
    "   adcq    %11, %%rax\n"
    "   movq    %%rax, %3\n"
  : "=m" (z[0]), "=m" (z[1]), "=m" (z[2]), "=m" (z[3])
  : "m" (x[0]), "m" (x[1]), "m" (x[2]), "m" (x[3]), "m" (y[0]), "m" (y[1]), "m" (y[2]), "m" (y[3])
  : "%rax");
}

#define HAVE_NATIVE_ADD_5 1
static void
add_5(mp_limb_t *z, const mp_limb_t *x, const mp_limb_t *y)
{
  __asm__ volatile (
    "   movq    %0, %%rdi\n"
    "   movq    %1, %%rsi\n"
    "   movq    %2, %%rdx\n"
    "   movq    (%%rsi), %%rax\n"
    "   addq    (%%rdx), %%rax\n"
    "   movq    %%rax, (%%rdi)\n"

    "   movq    8(%%rsi), %%rax\n"
    "   adcq    8(%%rdx), %%rax\n"
    "   movq    %%rax, 8(%%rdi)\n"

    "   movq    16(%%rsi), %%rax\n"
    "   adcq    16(%%rdx), %%rax\n"
    "   movq    %%rax, 16(%%rdi)\n"

    "   movq    24(%%rsi), %%rax\n"
    "   adcq    24(%%rdx), %%rax\n"
    "   movq    %%rax, 24(%%rdi)\n"

    "   movq    32(%%rsi), %%rax\n"
    "   adcq    32(%%rdx), %%rax\n"
    "   movq    %%rax, 32(%%rdi)\n"
  : "+m" (z)
  : "m" (x), "m" (y)
  : "%rax", "%rdx", "%rsi", "%rdi", "memory");
}

#define HAVE_NATIVE_ADD_6 1
static void
add_6(mp_limb_t *z, const mp_limb_t *x, const mp_limb_t *y)
{
  __asm__ volatile (
    "   movq    %0, %%rdi\n"
    "   movq    %1, %%rsi\n"
    "   movq    %2, %%rdx\n"
    "   movq    (%%rsi), %%rax\n"
    "   addq    (%%rdx), %%rax\n"
    "   movq    %%rax, (%%rdi)\n"

    "   movq    8(%%rsi), %%rax\n"
    "   adcq    8(%%rdx), %%rax\n"
    "   movq    %%rax, 8(%%rdi)\n"

    "   movq    16(%%rsi), %%rax\n"
    "   adcq    16(%%rdx), %%rax\n"
    "   movq    %%rax, 16(%%rdi)\n"

    "   movq    24(%%rsi), %%rax\n"
    "   adcq    24(%%rdx), %%rax\n"
    "   movq    %%rax, 24(%%rdi)\n"

    "   movq    32(%%rsi), %%rax\n"
    "   adcq    32(%%rdx), %%rax\n"
    "   movq    %%rax, 32(%%rdi)\n"

    "   movq    40(%%rsi), %%rax\n"
    "   adcq    40(%%rdx), %%rax\n"
    "   movq    %%rax, 40(%%rdi)\n"
  : "+m" (z)
  : "m" (x), "m" (y)
  : "%rax", "%rdx", "%rsi", "%rdi", "memory");
}

#define HAVE_NATIVE_ADD_7 1
static void
add_7(mp_limb_t *z, const mp_limb_t *x, const mp_limb_t *y)
{
  __asm__ volatile (
    "   movq    %0, %%rdi\n"
    "   movq    %1, %%rsi\n"
    "   movq    %2, %%rdx\n"
    "   movq    (%%rsi), %%rax\n"
    "   addq    (%%rdx), %%rax\n"
    "   movq    %%rax, (%%rdi)\n"

    "   movq    8(%%rsi), %%rax\n"
    "   adcq    8(%%rdx), %%rax\n"
    "   movq    %%rax, 8(%%rdi)\n"

    "   movq    16(%%rsi), %%rax\n"
    "   adcq    16(%%rdx), %%rax\n"
    "   movq    %%rax, 16(%%rdi)\n"

    "   movq    24(%%rsi), %%rax\n"
    "   adcq    24(%%rdx), %%rax\n"
    "   movq    %%rax, 24(%%rdi)\n"

    "   movq    32(%%rsi), %%rax\n"
    "   adcq    32(%%rdx), %%rax\n"
    "   movq    %%rax, 32(%%rdi)\n"

    "   movq    40(%%rsi), %%rax\n"
    "   adcq    40(%%rdx), %%rax\n"
    "   movq    %%rax, 40(%%rdi)\n"

    "   movq    48(%%rsi), %%rax\n"
    "   adcq    48(%%rdx), %%rax\n"
    "   movq    %%rax, 48(%%rdi)\n"
  : "+m" (z)
  : "m" (x), "m" (y)
  : "%rax", "%rdx", "%rsi", "%rdi", "memory");
}

#define HAVE_NATIVE_ADD_8 1
static void
add_8(mp_limb_t *z, const mp_limb_t *x, const mp_limb_t *y)
{
  __asm__ volatile (
    "   movq    %0, %%rdi\n"
    "   movq    %1, %%rsi\n"
    "   movq    %2, %%rdx\n"
    "   movq    (%%rsi), %%rax\n"
    "   addq    (%%rdx), %%rax\n"
    "   movq    %%rax, (%%rdi)\n"

    "   movq    8(%%rsi), %%rax\n"
    "   adcq    8(%%rdx), %%rax\n"
    "   movq    %%rax, 8(%%rdi)\n"

    "   movq    16(%%rsi), %%rax\n"
    "   adcq    16(%%rdx), %%rax\n"
    "   movq    %%rax, 16(%%rdi)\n"

    "   movq    24(%%rsi), %%rax\n"
    "   adcq    24(%%rdx), %%rax\n"
    "   movq    %%rax, 24(%%rdi)\n"

    "   movq    32(%%rsi), %%rax\n"
    "   adcq    32(%%rdx), %%rax\n"
    "   movq    %%rax, 32(%%rdi)\n"

    "   movq    40(%%rsi), %%rax\n"
    "   adcq    40(%%rdx), %%rax\n"
    "   movq    %%rax, 40(%%rdi)\n"

    "   movq    48(%%rsi), %%rax\n"
    "   adcq    48(%%rdx), %%rax\n"
    "   movq    %%rax, 48(%%rdi)\n"

    "   movq    56(%%rsi), %%rax\n"
    "   adcq    56(%%rdx), %%rax\n"
    "   movq    %%rax, 56(%%rdi)\n"
  : "+m" (z)
  : "m" (x), "m" (y)
  : "%rax", "%rdx", "%rsi", "%rdi", "memory");
}

#define HAVE_NATIVE_ADD_9 1
static void
add_9(mp_limb_t *z, const mp_limb_t *x, const mp_limb_t *y)
{
  __asm__ volatile (
    "   movq    %0, %%rdi\n"
    "   movq    %1, %%rsi\n"
    "   movq    %2, %%rdx\n"
    "   movq    (%%rsi), %%rax\n"
    "   addq    (%%rdx), %%rax\n"
    "   movq    %%rax, (%%rdi)\n"

    "   movq    8(%%rsi), %%rax\n"
    "   adcq    8(%%rdx), %%rax\n"
    "   movq    %%rax, 8(%%rdi)\n"

    "   movq    16(%%rsi), %%rax\n"
    "   adcq    16(%%rdx), %%rax\n"
    "   movq    %%rax, 16(%%rdi)\n"

    "   movq    24(%%rsi), %%rax\n"
    "   adcq    24(%%rdx), %%rax\n"
    "   movq    %%rax, 24(%%rdi)\n"

    "   movq    32(%%rsi), %%rax\n"
    "   adcq    32(%%rdx), %%rax\n"
    "   movq    %%rax, 32(%%rdi)\n"

    "   movq    40(%%rsi), %%rax\n"
    "   adcq    40(%%rdx), %%rax\n"
    "   movq    %%rax, 40(%%rdi)\n"

    "   movq    48(%%rsi), %%rax\n"
    "   adcq    48(%%rdx), %%rax\n"
    "   movq    %%rax, 48(%%rdi)\n"

    "   movq    56(%%rsi), %%rax\n"
    "   adcq    56(%%rdx), %%rax\n"
    "   movq    %%rax, 56(%%rdi)\n"

    "   movq    64(%%rsi), %%rax\n"
    "   adcq    64(%%rdx), %%rax\n"
    "   movq    %%rax, 64(%%rdi)\n"
  : "+m" (z)
  : "m" (x), "m" (y)
  : "%rax", "%rdx", "%rsi", "%rdi", "memory");
}

#endif  /* __MP_X86_64_H__ */
